## boost1.74 1.74.0

=== libs/atomic/CMakeLists.txt ===
# Copyright 2018 Mike Dev
# Copyright 2019 Peter Dimov
# Copyright 2020 Andrey Semashev
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)
project(boost_atomic VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

include(CheckCXXSourceCompiles)

set(boost_atomic_sources src/lock_pool.cpp)
if(WIN32)
    set(boost_atomic_sources ${boost_atomic_sources} src/wait_ops_windows.cpp)
endif()

if(WIN32)
    # Note: We can't use the Boost::library targets here as they may not yet be included by the superproject when this CMakeLists.txt is included.
    set(CMAKE_REQUIRED_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/../..")
    set(CMAKE_REQUIRED_LIBRARIES synchronization)
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_synchronization.cpp>" BOOST_ATOMIC_HAS_SYNCHRONIZATION)
    unset(CMAKE_REQUIRED_LIBRARIES)
    unset(CMAKE_REQUIRED_INCLUDES)
endif()

add_library(boost_atomic ${boost_atomic_sources})
add_library(Boost::atomic ALIAS boost_atomic)

target_include_directories(boost_atomic PUBLIC include)
target_include_directories(boost_atomic PRIVATE src)

target_link_libraries(boost_atomic
    PUBLIC
        Boost::assert
        Boost::config
        Boost::static_assert
        Boost::type_traits
    PRIVATE
        Boost::predef
        Boost::preprocessor
)

if(WIN32)
    target_link_libraries(boost_atomic
        PUBLIC
            Boost::winapi
    )

    if(BOOST_ATOMIC_HAS_SYNCHRONIZATION)
        target_link_libraries(boost_atomic PRIVATE synchronization)
    endif()
endif()

target_compile_definitions(boost_atomic
    PUBLIC
        BOOST_ATOMIC_NO_LIB
    PRIVATE
        BOOST_ATOMIC_SOURCE
)

if(BUILD_SHARED_LIBS)
    target_compile_definitions(boost_atomic PUBLIC BOOST_ATOMIC_DYN_LINK)
else()
    target_compile_definitions(boost_atomic PUBLIC BOOST_ATOMIC_STATIC_LINK)
endif()

=== libs/beast/CMakeLists.txt ===
#
# Copyright (c) 2016-2017 Vinnie Falco (vinnie dot falco at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/beast
#

cmake_minimum_required (VERSION 3.5.1)

if (POLICY CMP0074)
    cmake_policy (SET CMP0074 NEW)
endif()

#-------------------------------------------------------------------------------

function (DoGroupSources curdir rootdir folder)
    file (GLOB children RELATIVE ${PROJECT_SOURCE_DIR}/${curdir} ${PROJECT_SOURCE_DIR}/${curdir}/*)
    foreach (child ${children})
        if (IS_DIRECTORY ${PROJECT_SOURCE_DIR}/${curdir}/${child})
            DoGroupSources (${curdir}/${child} ${rootdir} ${folder})
        elseif (${child} STREQUAL "CMakeLists.txt")
            source_group("" FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        else()
            string (REGEX REPLACE ^${rootdir} ${folder} groupname ${curdir})
            string (REPLACE "/" "\\" groupname ${groupname})
            source_group (${groupname} FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        endif()
    endforeach()
endfunction()

function (GroupSources curdir folder)
    DoGroupSources (${curdir} ${curdir} ${folder})
endfunction()

#-------------------------------------------------------------------------------
#
# Beast
#
#-------------------------------------------------------------------------------

project (Beast VERSION 300)

set_property (GLOBAL PROPERTY USE_FOLDERS ON)
option (Beast_BUILD_EXAMPLES "Build examples" ON)
option (Beast_BUILD_TESTS "Build tests" ON)

if (MSVC)
    set (CMAKE_VERBOSE_MAKEFILE FALSE)

    add_definitions (
        -D_WIN32_WINNT=0x0601
        -D_SCL_SECURE_NO_WARNINGS=1
        -D_CRT_SECURE_NO_WARNINGS=1
        -D_SILENCE_CXX17_ALLOCATOR_VOID_DEPRECATION_WARNING
        -D_SILENCE_CXX17_ADAPTOR_TYPEDEFS_DEPRECATION_WARNING
    )

    add_compile_options(
        /bigobj       # large object file format
        /permissive-  # strict C++
        #/wd4503      # decorated name length exceeded, name was truncated
        /W4           # enable all warnings
        /MP           # Multi-processor compilation
        )

    set (Boost_USE_STATIC_LIBS ON)
    set (Boost_USE_STATIC_RUNTIME ON)

    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Ob2 /Oi /Ot /GL /MT")
    set (CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Oi /Ot /MT")

    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
    set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    # for RelWithDebInfo builds, disable incremental linking
    # since CMake sets it ON by default for that build type and it
    # causes warnings
    #
    string (REPLACE "/INCREMENTAL" "/INCREMENTAL:NO" replacement_flags
        ${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO})
    set (CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO ${replacement_flags})

else()
    set (THREADS_PREFER_PTHREAD_FLAG ON)
    find_package (Threads)
    link_libraries(Threads::Threads)


    set( CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -Wpedantic -Wno-unused-parameter")

    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wrange-loop-analysis")
    endif ()
endif()

# Must come before Boost includes, otherwise the
# IDE sees the wrong file due to boost/ symlinks.
include_directories (include)

#-------------------------------------------------------------------------------
#
# OpenSSL
#
#-------------------------------------------------------------------------------

if (APPLE AND NOT DEFINED ENV{OPENSSL_ROOT_DIR})
  find_program(HOMEBREW brew)
  if (NOT HOMEBREW STREQUAL "HOMEBREW-NOTFOUND")
    execute_process(COMMAND brew --prefix openssl
      OUTPUT_VARIABLE OPENSSL_ROOT_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()

find_package(OpenSSL)
if (NOT MSVC)
    link_libraries(${OPENSSL_LIBRARIES})
endif()

#-------------------------------------------------------------------------------
#
# Boost
#
#-------------------------------------------------------------------------------

get_filename_component (BOOST_ROOT ../../ ABSOLUTE)

# VFALCO I want static but "b2 stage" builds a minimal set which excludes static
add_definitions (-DBOOST_ALL_STATIC_LINK=1)

add_definitions (-DBOOST_ASIO_NO_DEPRECATED=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_ARRAY=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_BIND=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_DATE_TIME=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_REGEX=1)
add_definitions (-DBOOST_COROUTINES_NO_DEPRECATION_WARNING=1)

if (MSVC)
include_directories (${BOOST_ROOT})
else()
    set(BOOST_INCLUDEDIR ${BOOST_ROOT})
    set(BOOST_LIBRARYDIR ${BOOST_ROOT}/stage/lib)
    find_package(Boost COMPONENTS coroutine filesystem system REQUIRED)
    link_libraries(Boost::coroutine Boost::filesystem Boost::system)
endif()

link_directories(${BOOST_ROOT}/stage/lib)

if (MINGW)
    link_libraries(ws2_32 mswsock)
endif()

#-------------------------------------------------------------------------------

if ("${VARIANT}" STREQUAL "coverage")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE DEBUG)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2 --coverage")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
    endif()

elseif ("${VARIANT}" STREQUAL "ubasan")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE RELWITHDEBINFO)
        set (CMAKE_CXX_FLAGS
          "${CMAKE_CXX_FLAGS} -DBOOST_BEAST_NO_SLOW_TESTS=1 -msse4.2 -funsigned-char -fno-omit-frame-pointer -fsanitize=address,undefined -fno-sanitize-recover=address,undefined -fsanitize-blacklist=${PROJECT_SOURCE_DIR}/tools/blacklist.supp")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address,undefined -fno-sanitize-recover=address,undefined")
    endif()

elseif ("${VARIANT}" STREQUAL "debug")
    set (CMAKE_BUILD_TYPE DEBUG)

elseif ("${VARIANT}" STREQUAL "release")
    set (CMAKE_BUILD_TYPE RELEASE)

endif()

#-------------------------------------------------------------------------------
#
# Static Libraries
#
#-------------------------------------------------------------------------------

add_definitions (-DBOOST_ASIO_SEPARATE_COMPILATION=1)
add_definitions (-DBOOST_BEAST_SEPARATE_COMPILATION=1)

GroupSources (test "/")

add_library (
    lib-asio STATIC
    test/lib_asio.cpp
)

set_property(TARGET lib-asio PROPERTY FOLDER "static-libs")

add_library (
    lib-asio-ssl STATIC
    test/lib_asio_ssl.cpp
)

set_property(TARGET lib-asio-ssl PROPERTY FOLDER "static-libs")

add_library (
    lib-beast STATIC
    test/lib_beast.cpp
)

set_property(TARGET lib-beast PROPERTY FOLDER "static-libs")

target_link_libraries(lib-beast lib-asio)

#-------------------------------------------------------------------------------
#
# Tests and examples
#

include_directories (.)

if (OPENSSL_FOUND)
    include_directories (${OPENSSL_INCLUDE_DIR})
endif()

file (GLOB_RECURSE BOOST_BEAST_FILES
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.hpp
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.ipp
)

file (GLOB_RECURSE BOOST_BEAST_EXPERIMENTAL_FILES
    ${PROJECT_SOURCE_DIR}/include/boost/beast/_experimental/*.hpp
    ${PROJECT_SOURCE_DIR}/include/boost/beast/_experimental/*.ipp
)

file (GLOB_RECURSE COMMON_FILES
    ${PROJECT_SOURCE_DIR}/example/common/*.hpp
  )

if (Beast_BUILD_EXAMPLES AND
    (NOT "${VARIANT}" STREQUAL "coverage") AND
    (NOT "${VARIANT}" STREQUAL "ubasan"))
    add_subdirectory (example)
endif()

if (Beast_BUILD_TESTS)
    add_subdirectory (test)
endif()

=== libs/callable_traits/CMakeLists.txt ===

# Copyright Louis Dionne 2015
# Modified Work Copyright Barrett Adair 2015-2017
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.0)
project(boost_callable_traits CXX)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
enable_testing()

set (CMAKE_CXX_STANDARD ${boost_callable_traits_CXX_STD})

# Setting up CMake options and compiler flags (more flags can be set on a per-target basis or in subdirectories)

include(CheckCXXCompilerFlag)
macro(boost_callable_traits_append_flag testname flag)
    check_cxx_compiler_flag(${flag} ${testname})
    if (${testname})
        add_compile_options(${flag})
    endif()
endmacro()

if(NOT MSVC OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")

    # enable all warnings and treat them all as errors
    boost_callable_traits_append_flag(boost_callable_traits_HAS_WERROR -Werror)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_WX -WX)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_W                          -W)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_WALL                       -Wall)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_WEXTRA                     -Wextra)
endif()

if(MSVC)

    # MSVC/Clang-cl builds need -Qunused-arguments
    boost_callable_traits_append_flag(boost_callable_traits_HAS_QUNUSED_ARGUMENTS          -Qunused-arguments)
else()

    # for better template error debugging
    boost_callable_traits_append_flag(boost_callable_traits_HAS_FTEMPLATE_BACKTRACE_LIMIT  -ftemplate-backtrace-limit=0)
    
    # enforce strict standards compliance
    boost_callable_traits_append_flag(boost_callable_traits_HAS_PEDANTIC                   -pedantic)
    
    # use the most recent C++ standard available
    boost_callable_traits_append_flag(boost_callable_traits_HAS_STDCXX0x                   -std=c++0x)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_STDCXX1y                   -std=c++1y)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_STDCXX1z                   -std=c++1z)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_STDCXX17                   -std=c++17)
    boost_callable_traits_append_flag(boost_callable_traits_HAS_STDCXX2a                   -std=c++2a)
endif()

# transactional memory - currently only available in GCC 6 and later
if(NOT ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    boost_callable_traits_append_flag(boost_callable_traits_HAS_FGNU_TM                    -fgnu-tm)
endif()

add_library(boost_callable_traits INTERFACE)
set_property(TARGET boost_callable_traits PROPERTY EXPORT_NAME callable_traits)
add_library(Boost::callable_traits ALIAS boost_callable_traits)

target_include_directories(boost_callable_traits INTERFACE
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
    $<INSTALL_INTERFACE:include>)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

#
#find_package(Doxygen)
##find_package(Meta)
#find_package(PythonInterp 2.7)
#find_package(Ruby 2.1)

##############################################################################
# boost_callable_traits_target_name_for(<output variable> <source file> [ext])
# Returns the target name associated to a source file. If the path of the
# source file relative from the root of boost_callable_traits is `path/to/source/file.ext`,
# the target name associated to it will be `path.to.source.file`.
#
# The extension of the file should be specified as a last argument. If no
# extension is specified, the `.cpp` extension is assumed.
##############################################################################

function(boost_callable_traits_target_name_for out file)
    if (NOT ARGV2)
        set(_extension ".cpp")
    else()
        set(_extension "${ARGV2}")
    endif()

    file(RELATIVE_PATH _relative ${boost_callable_traits_SOURCE_DIR} ${file})
    string(REPLACE "${_extension}" "" _name ${_relative})
    string(REGEX REPLACE "/" "." _name ${_name})
    set(${out} "${_name}" PARENT_SCOPE)
endfunction()

##############################################################################
# boost_callable_traits_add_test(<name> <command> [<arg>...])
# Creates a test called `name`, which runs the given `command` with the given args.
##############################################################################

function(boost_callable_traits_add_test name)
    if (boost_callable_traits_ENABLE_MEMCHECK)
        add_test(${name} ${Valgrind_EXECUTABLE} --leak-check=full --error-exitcode=1 ${ARGN})
    else()
        add_test(${name} ${ARGN})
    endif()
endfunction()

##############################################################################
# Setup the `check` target to build and then run all the tests and examples.
##############################################################################

add_custom_target(callable_traits_check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Build and then run all the tests and examples.")
if (NOT TARGET check)
    add_custom_target(check DEPENDS callable_traits_check)
else()
    add_dependencies(check callable_traits_check)
endif()

add_subdirectory(example)
add_subdirectory(test)

##############################################################################
# Setup the 'install' target and the package config file.
##############################################################################
install(TARGETS boost_callable_traits     EXPORT CallableTraitsConfig)
install(EXPORT CallableTraitsConfig DESTINATION lib/cmake/CallableTraits)
install(DIRECTORY include/boost     DESTINATION include FILES_MATCHING PATTERN "*.hpp")

endif()

=== libs/chrono/CMakeLists.txt ===
# Copyright 2019 Mike Dev
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt
#
# NOTE: CMake support for Boost.Chrono is currently experimental at best
#       and the interface is likely to change in the future

cmake_minimum_required( VERSION 3.5 )
project( BoostChrono LANGUAGES CXX)

add_library( boost_chrono
    src/chrono.cpp
    src/process_cpu_clocks.cpp
    src/thread_clock.cpp
)
add_library( Boost::chrono ALIAS boost_chrono )

target_include_directories( boost_chrono PUBLIC include )
target_compile_definitions( boost_chrono
    PUBLIC
        # NOTE:
        # We deactivate autolinking because cmake based builds don't need it
        # and we don't implement name mangling for the library file anyway.
        # Ususally the parent CMakeLists.txt file should already have globally defined BOOST_ALL_NO_LIB
        BOOST_CHRONO_NO_LIB
        $<$<STREQUAL:$<TARGET_PROPERTY:boost_chrono,TYPE>,SHARED_LIBRARY>:BOOST_CHRONO_DYN_LINK=1>
        $<$<STREQUAL:$<TARGET_PROPERTY:boost_chrono,TYPE>,STATIC_LIBRARY>:BOOST_CHRONO_STATIC_LINK=1>
)

target_link_libraries( boost_chrono
    PUBLIC
        Boost::assert
        Boost::config
        Boost::core
        Boost::integer
        Boost::move
        Boost::mpl
        Boost::predef
        Boost::ratio
        Boost::static_assert
        Boost::system
        Boost::throw_exception
        Boost::type_traits
        Boost::typeof
        Boost::utility
     PRIVATE
        $<$<STREQUAL:Windows,$<PLATFORM_ID>>:Boost::winapi>
)

=== libs/hof/CMakeLists.txt ===
#=============================================================================
#    Copyright (c) 2017 Paul Fultz II
#    CMakeLists.txt
#    Distributed under the Boost Software License, Version 1.0. (See accompanying
#    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#==============================================================================
cmake_minimum_required (VERSION 2.8)
project (boost_hof)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

foreach(level MAJOR MINOR PATCH)
    file(STRINGS include/boost/hof/version.hpp
                 _define_${level}
                 REGEX "#define BOOST_HOF_${level}_VERSION")
    string(REGEX MATCH "([0-9]+)" boost_hof_VERSION_${level} "${_define_${level}}")
endforeach() 

include(CheckCXXCompilerFlag)
enable_language(CXX)

if(NOT CMAKE_CXX_FLAGS MATCHES "-std=")

    if(CMAKE_HOST_APPLE)
      check_cxx_compiler_flag("-stdlib=libc++" COMPILER_HAS_CXX_FLAG_libcxx)
      if(COMPILER_HAS_CXX_FLAG_libcxx)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
      endif()
    endif()

    set(ENABLE_CXXFLAGS_TO_CHECK 
        -std=gnu++17
        -std=c++17
        -std=gnu++1z
        -std=c++1z
        -std=gnu++14
        -std=c++14
        -std=gnu++1y 
        -std=c++1y
        -std=gnu++11 
        -std=c++11
        -std=gnu++0x 
        -std=c++0x)

    foreach(flag ${ENABLE_CXXFLAGS_TO_CHECK})
        string(REPLACE "-std=" "_" flag_var ${flag})
        string(REPLACE "+" "x" flag_var ${flag_var})
        check_cxx_compiler_flag("${flag}" COMPILER_HAS_CXX_FLAG${flag_var})
        if(COMPILER_HAS_CXX_FLAG${flag_var})
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
            break()
        endif()
    endforeach()

endif()

install (DIRECTORY include/boost DESTINATION include)
configure_file(boost_hof.pc.in boost_hof.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/boost_hof.pc DESTINATION lib/pkgconfig)

include(SphinxDoc)

add_sphinx_doc(${CMAKE_CURRENT_SOURCE_DIR}/doc HTML_DIR ${CMAKE_CURRENT_SOURCE_DIR}/doc/html)

include(BCMTest)

include_directories(include)

file(GLOB TESTS test/*.cpp)
foreach(TEST ${TESTS})
    get_filename_component(BASE_NAME ${TEST} NAME_WE)
    bcm_add_test(NAME ${BASE_NAME} SOURCES ${TEST})
    set_tests_properties(${BASE_NAME} PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
endforeach()
bcm_add_test(NAME static_def SOURCES test/static_def/static_def.cpp test/static_def/static_def2.cpp)
set_tests_properties(static_def PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")

file(GLOB FAIL_TESTS test/fail/*.cpp)
foreach(TEST ${FAIL_TESTS})
    get_filename_component(BASE_NAME ${TEST} NAME_WE)
    bcm_add_test(NAME fail-${BASE_NAME} COMPILE_ONLY WILL_FAIL SOURCES ${TEST})
endforeach()

file(GLOB HEADERS include/boost/hof/*.hpp)
foreach(HEADER ${HEADERS})
    get_filename_component(BASE_NAME ${HEADER} NAME_WE)
    bcm_test_header(NAME ${BASE_NAME} HEADER boost/hof/${BASE_NAME}.hpp STATIC)
endforeach()
bcm_test_header(NAME hof HEADER boost/hof.hpp STATIC)

function(extract_doc SOURCE OUTPUTVAR)
    file(READ ${SOURCE} CONTENT)
    string(REGEX REPLACE "(\n(/[^/][^/]|//[^/]|[^/][^/][^/])([^\n])*)" "" CONTENT "\n${CONTENT}")
    string(REPLACE "/// " "" CONTENT "${CONTENT}")
    set(${OUTPUTVAR} "${CONTENT}" PARENT_SCOPE)
endfunction()

function(build_example SECTIONCONTENT NAME)
    string(MD5 MD5_SECTION "${SECTIONCONTENT}")
    set(TARGET_NAME "example-${NAME}-${MD5_SECTION}")
    set(CONTENT "")
    foreach(LINE ${SECTIONCONTENT})
        if(LINE MATCHES "^    ")
            string(SUBSTRING ${LINE} "4" "-1" OUTPUT_LINE)
            list(APPEND CONTENT ${OUTPUT_LINE})
        endif()
    endforeach()
    string(REPLACE ";" "\n" CONTENT "${CONTENT}")
    string(REPLACE "$$__semicolon__$$" ";" CONTENT "${CONTENT}")
    if(NOT CONTENT MATCHES "int main")
        string(APPEND CONTENT "int main() {}")
    endif()
    message(STATUS "Adding example: ${TARGET_NAME}")
    bcm_add_test(NAME ${TARGET_NAME} CONTENT "${CONTENT}\n")
endfunction()

function(extract_example SOURCE)
    extract_doc(${SOURCE} CONTENT)
    string(REPLACE ";" "$$__semicolon__$$" CONTENT "${CONTENT}")
    string(REPLACE "\n" ";" CONTENT "${CONTENT}")

    get_filename_component(BASE_NAME ${SOURCE} NAME_WE)

    set(SECTION "")
    set(PREVLINE "")
    set(APPEND_SECTION Off)
    foreach(LINE ${CONTENT})
        if(APPEND_SECTION)
            if((LINE MATCHES "^---") OR (LINE MATCHES "^==="))
                build_example("${SECTION}" ${BASE_NAME})
                set(APPEND_SECTION Off)
                set(SECTION "")
            elseif(NOT PREVLINE MATCHES "^---")
                list(APPEND SECTION ${PREVLINE})
            endif()
        else()
            if((LINE MATCHES "^---") AND (PREVLINE MATCHES "^Example"))
                set(APPEND_SECTION One)
            endif()
        endif()
        set(PREVLINE "${LINE}")
    endforeach()
    list(APPEND SECTION ${PREVLINE})
    if(APPEND_SECTION)
        build_example("${SECTION}" ${BASE_NAME})
    endif()
endfunction()

set(BUILD_EXAMPLES off CACHE BOOL "Set this to build the examples")

if (BUILD_EXAMPLES)
    file(GLOB EXAMPLES example/*.cpp)
    foreach(EXAMPLE ${EXAMPLES})
        get_filename_component(BASE_NAME ${EXAMPLE} NAME_WE)
        bcm_add_test(NAME example-${BASE_NAME} SOURCES ${EXAMPLE})
    endforeach()
    foreach(HEADER ${HEADERS})
        extract_example(${HEADER})
    endforeach()
endif()

=== libs/io/CMakeLists.txt ===
# Copyright 2018 Mike Dev
#
# Distributed under the Boost Software License, Version 1.0.
# (http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.5)

project(BoostIO LANGUAGES CXX)

add_library(boost_io INTERFACE)
add_library(Boost::io ALIAS boost_io)

target_include_directories(boost_io INTERFACE include)

target_link_libraries(boost_io INTERFACE Boost::config)

=== libs/mp11/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_mp11 VERSION 1.74.0 LANGUAGES CXX)

add_library(boost_mp11 INTERFACE)
add_library(Boost::mp11 ALIAS boost_mp11)

target_include_directories(boost_mp11 INTERFACE include)
target_compile_features(boost_mp11 INTERFACE cxx_alias_templates cxx_variadic_templates cxx_decltype)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  # Fetch support files

  message(STATUS "Fetching BoostFetch.cmake")

  file(DOWNLOAD
    "https://raw.githubusercontent.com/boostorg/cmake/develop/include/BoostFetch.cmake"
    "${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake"
  )

  include("${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake")

  boost_fetch(boostorg/cmake TAG develop NO_ADD_SUBDIR)

  FetchContent_GetProperties(boostorg_cmake)

  list(APPEND CMAKE_MODULE_PATH ${boostorg_cmake_SOURCE_DIR}/include)

  # Enable testing

  include(CTest)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

  if(BUILD_TESTING)

    set(BUILD_TESTING OFF) # hide cache variable

    boost_fetch(boostorg/assert TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/config TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/core TAG develop EXCLUDE_FROM_ALL)

    unset(BUILD_TESTING)

  endif()

  # Do not use the default BoostInstall versioned layout on Windows when standalone
  set(BOOST_INSTALL_LAYOUT "system" CACHE STRING "Installation layout (versioned, tagged, or system)")

endif()

include(BoostInstall OPTIONAL RESULT_VARIABLE HAVE_BOOST_INSTALL)

if(HAVE_BOOST_INSTALL)

  boost_install(TARGETS boost_mp11 HEADER_DIRECTORY include/)

endif()

if(BUILD_TESTING)

  add_subdirectory(test)

endif()

=== libs/system/CMakeLists.txt ===
# Copyright 2018-2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_system VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_system INTERFACE)
add_library(Boost::system ALIAS boost_system)

target_include_directories(boost_system INTERFACE include)

target_link_libraries(boost_system
  INTERFACE
    Boost::config
    Boost::winapi
)

if(BUILD_TESTING)

  add_subdirectory(test)

endif()

=== libs/tuple/CMakeLists.txt ===
# Copyright 2018 Mike Dev
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt
#
# NOTE: CMake support for Boost.Tuple is currently experimental at best
#       and the interface is likely to change in the future

cmake_minimum_required(VERSION 3.5)
project(BoostTuple)

add_library(boost_tuple INTERFACE)
add_library(Boost::tuple ALIAS boost_tuple)

target_include_directories(boost_tuple INTERFACE include)

target_link_libraries(boost_tuple
    INTERFACE
        Boost::config
        Boost::core
        Boost::static_assert
        Boost::type_traits
)

=== libs/histogram/test/CMakeLists.txt ===
# Copyright Hans Dembinski 2019
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

find_package(PythonInterp)
if (PYTHONINTERP_FOUND)
  # checks that b2 and cmake are in sync
  add_test(NAME runpy-${PROJECT_NAME}_check_build_system COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/check_build_system.py)

  # checks that all headers are included in odr test
  add_test(NAME runpy-${PROJECT_NAME}_check_odr_test COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/check_odr_test.py)
endif()

include(BoostTest OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)
if(NOT HAVE_BOOST_TEST)
  return()
endif()

set(BOOST_TEST_LINK_LIBRARIES Boost::histogram)

# keep in sync with Jamfile, this should be automatized...
boost_test(TYPE compile-fail SOURCES axis_category_fail0.cpp)
boost_test(TYPE compile-fail SOURCES axis_category_fail1.cpp)
boost_test(TYPE compile-fail SOURCES axis_category_fail2.cpp)
boost_test(TYPE compile-fail SOURCES axis_integer_fail0.cpp)
boost_test(TYPE compile-fail SOURCES axis_integer_fail1.cpp)
boost_test(TYPE compile-fail SOURCES axis_integer_fail2.cpp)
boost_test(TYPE compile-fail SOURCES axis_integer_fail3.cpp)
boost_test(TYPE compile-fail SOURCES axis_integer_fail4.cpp)
boost_test(TYPE compile-fail SOURCES axis_regular_fail0.cpp)
boost_test(TYPE compile-fail SOURCES axis_regular_fail1.cpp)
boost_test(TYPE compile-fail SOURCES axis_variable_fail0.cpp)
boost_test(TYPE compile-fail SOURCES axis_variable_fail1.cpp)
boost_test(TYPE compile-fail SOURCES make_histogram_fail0.cpp)
boost_test(TYPE compile-fail SOURCES make_histogram_fail1.cpp)
boost_test(TYPE compile-fail SOURCES histogram_fail0.cpp)
boost_test(TYPE compile-fail SOURCES histogram_fail1.cpp)
boost_test(TYPE compile-fail SOURCES histogram_fail2.cpp)
boost_test(TYPE compile-fail SOURCES histogram_fail3.cpp)
boost_test(TYPE compile-fail SOURCES histogram_fail4.cpp)

set(BOOST_TEST_LINK_LIBRARIES Boost::histogram Boost::core)

boost_test(TYPE run SOURCES accumulators_count_test.cpp)
boost_test(TYPE run SOURCES accumulators_mean_test.cpp)
boost_test(TYPE run SOURCES accumulators_sum_test.cpp)
boost_test(TYPE run SOURCES accumulators_thread_safe_test.cpp)
boost_test(TYPE run SOURCES accumulators_weighted_mean_test.cpp)
boost_test(TYPE run SOURCES accumulators_weighted_sum_test.cpp)
boost_test(TYPE run SOURCES algorithm_project_test.cpp)
boost_test(TYPE run SOURCES algorithm_reduce_test.cpp)
boost_test(TYPE run SOURCES algorithm_sum_test.cpp)
boost_test(TYPE run SOURCES algorithm_empty_test.cpp)
boost_test(TYPE run SOURCES axis_boolean_test.cpp)
boost_test(TYPE run SOURCES axis_category_test.cpp)
boost_test(TYPE run SOURCES axis_integer_test.cpp)
boost_test(TYPE run SOURCES axis_option_test.cpp)
boost_test(TYPE run SOURCES axis_regular_test.cpp)
boost_test(TYPE run SOURCES axis_traits_test.cpp)
boost_test(TYPE run SOURCES axis_variable_test.cpp)
boost_test(TYPE run SOURCES axis_variant_test.cpp)
boost_test(TYPE run SOURCES detail_accumulator_traits_test.cpp)
boost_test(TYPE run SOURCES detail_argument_traits_test.cpp)
boost_test(TYPE run SOURCES detail_args_type_test.cpp)
boost_test(TYPE run SOURCES detail_axes_test.cpp)
boost_test(TYPE run SOURCES detail_convert_integer_test.cpp)
boost_test(TYPE run SOURCES detail_detect_test.cpp)
boost_test(TYPE run SOURCES detail_limits_test.cpp)
boost_test(TYPE run SOURCES detail_make_default_test.cpp)
boost_test(TYPE run SOURCES detail_misc_test.cpp)
boost_test(TYPE run SOURCES detail_large_int_test.cpp)
boost_test(TYPE run SOURCES detail_iterator_adaptor_test.cpp)
boost_test(TYPE run SOURCES detail_operators_test.cpp)
boost_test(TYPE run SOURCES detail_relaxed_equal_test.cpp)
boost_test(TYPE run SOURCES detail_replace_type_test.cpp)
boost_test(TYPE run SOURCES detail_safe_comparison_test.cpp)
boost_test(TYPE run SOURCES detail_static_if_test.cpp)
boost_test(TYPE run SOURCES detail_tuple_slice_test.cpp)
boost_test(TYPE run SOURCES histogram_custom_axis_test.cpp)
boost_test(TYPE run SOURCES histogram_dynamic_test.cpp)
boost_test(TYPE run SOURCES histogram_fill_test.cpp
  COMPILE_OPTIONS $<$<CXX_COMPILER_ID:MSVC>:/bigobj>)
boost_test(TYPE run SOURCES histogram_growing_test.cpp)
boost_test(TYPE run SOURCES histogram_mixed_test.cpp)
boost_test(TYPE run SOURCES histogram_operators_test.cpp
  COMPILE_OPTIONS $<$<CXX_COMPILER_ID:MSVC>:/bigobj>)
boost_test(TYPE run SOURCES histogram_ostream_test.cpp)
boost_test(TYPE run SOURCES histogram_test.cpp)
boost_test(TYPE run SOURCES indexed_test.cpp)
boost_test(TYPE run SOURCES storage_adaptor_test.cpp)
boost_test(TYPE run SOURCES unlimited_storage_test.cpp)
boost_test(TYPE run SOURCES utility_test.cpp)

find_package(Threads)
if (Threads_FOUND)

  boost_test(TYPE run SOURCES histogram_threaded_test.cpp
    LINK_LIBRARIES Threads::Threads)
  boost_test(TYPE run SOURCES storage_adaptor_threaded_test.cpp
    LINK_LIBRARIES Threads::Threads)

endif()

## No cmake support yet
# boost_test(TYPE link SOURCES odr_main_test.cpp odr_test.cpp
#   LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES boost_accumulators_support_test.cpp
#   LINK_LIBRARIES Boost::accumulators)
# boost_test(TYPE run SOURCES boost_range_support_test.cpp
#   LINK_LIBRARIES Boost::range)
# boost_test(TYPE run SOURCES boost_units_support_test.cpp
#   LINK_LIBRARIES Boost::units)
# boost_test(TYPE run SOURCES detail_array_wrapper_serialization_test.cpp   LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES unlimited_storage_serialization_test.cpp  LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES storage_adaptor_serialization_test.cpp  LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES histogram_serialization_test.cpp  LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES axis_variant_serialization_test.cpp
#     LINK_LIBRARIES Boost::serialization)
# boost_test(TYPE run SOURCES accumulators_serialization_test.cpp
#     LINK_LIBRARIES Boost::serialization)

boost_test(TYPE run SOURCES deduction_guides_test.cpp COMPILE_FEATURES cxx_std_17)

=== libs/safe_numerics/test/CMakeLists.txt ===
# CMake build control file for safe numerics Library tests

###########################
# test targets

message( STATUS "Runtimes are stored in ${CMAKE_CURRENT_BINARY_DIR}" )

# compile and run tests
set( run_test_list
  test_add_automatic
  test_add_native
  test_and_automatic
  test_and_native
  test_assignment
  test_auto
  test_cast
  test_checked_add
  test_checked_and
  test_checked_cast
  test_checked_divide
  test_checked_equal_to
  test_checked_left_shift
  test_checked_less_than
  test_checked_modulus
  test_checked_multiply
  test_checked_or
  test_checked_right_shift
  test_checked_subtract
  test_checked_xor
  test_construction
  test_cpp
  test_divide_automatic
  test_divide_native
  test_equal_automatic
  test_equal_native
  test_float
  test_interval
  test_left_shift_automatic
  test_left_shift_native
  test_less_than_automatic
  test_less_than_native
  test_modulus_automatic
  test_modulus_native
  test_multiply_automatic
  test_multiply_native
  test_or_automatic
  test_or_native
  # test_performance
  test_range
  test_rational
  test_right_shift_automatic
  test_right_shift_native
  test_safe_compare
  test_subtract_automatic
  test_subtract_native
  test_xor_automatic
  test_xor_native
  test_z
)

foreach(test_name ${run_test_list})
  test_run_pass(${test_name})
  set_target_properties(${test_name} PROPERTIES FOLDER "safe numeric runtime tests")
endforeach(test_name)

# compile fail tests
set(compile_fail_test_list
  test_trap
  test_constexpr
)

foreach(test_name ${compile_fail_test_list})
  test_compile_fail(${test_name})
  set_target_properties(${test_name} PROPERTIES FOLDER "safe numeric compile fail tests")
endforeach(test_name)

## safe integer constexpr tests
set(safe_constexpr_test_list
  test_add_automatic_constexpr
  test_add_native_constexpr
  test_cast_constexpr
  test_divide_automatic_constexpr
  test_divide_native_constexpr
  test_equal_automatic_constexpr
  test_equal_native_constexpr
  test_left_shift_automatic_constexpr
  test_left_shift_native_constexpr
  test_less_than_automatic_constexpr
  test_less_than_native_constexpr
  test_modulus_automatic_constexpr
  test_modulus_native_constexpr
  test_multiply_automatic_constexpr
  test_multiply_native_constexpr
  test_or_automatic_constexpr
  test_or_native_constexpr
  test_right_shift_automatic_constexpr
  test_right_shift_native_constexpr
  test_xor_automatic_constexpr
  test_xor_native_constexpr
  test_subtract_native_constexpr
  test_subtract_automatic_constexpr
)

foreach(test_name ${safe_constexpr_test_list})
  test_compile_pass(${test_name})
  set_target_properties(${test_name} PROPERTIES FOLDER "safe constexpr tests - compile only")
endforeach(test_name)

# checked results constexpr

set(checked_result_test_list
  test_checked_add_constexpr
  test_checked_and_constexpr
  test_checked_cast_constexpr
  test_checked_divide_constexpr
  test_checked_equal_to_constexpr
  test_checked_left_shift_constexpr
  test_checked_less_than_constexpr
  test_checked_modulus_constexpr
  test_checked_multiply_constexpr
  test_checked_or_constexpr
  test_checked_right_shift_constexpr
  test_checked_subtract_constexpr
  test_checked_xor_constexpr
)

foreach(test_name ${checked_result_test_list})
  test_compile_pass(${test_name})
  set_target_properties(${test_name} PROPERTIES FOLDER "checked result tests - compile only")
endforeach(test_name)

# end test targets
####################

###########################
# add headers to IDE

if(0)
file(GLOB include_files 
  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" 
  "${CMAKE_CURRENT_SOURCE_DIR}/*.hpp"
)
add_custom_target(include SOURCES ${include_files})
set_target_properties(include PROPERTIES FOLDER "tests")
endif(0)

# end headers in IDE
####################

=== libs/system/test/CMakeLists.txt ===
# Copyright 2018-2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

include(BoostTest OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if(NOT HAVE_BOOST_TEST)
  return()
endif()

macro(system_run s1)

  string(MAKE_C_IDENTIFIER ${s1} n1)

  boost_test(SOURCES ${s1} ${ARGN})
  boost_test(SOURCES ${s1} ${ARGN} COMPILE_DEFINITIONS BOOST_NO_ANSI_APIS NAME ${n1}_no_ansi)
  boost_test(SOURCES ${s1} ${ARGN} COMPILE_DEFINITIONS BOOST_SYSTEM_USE_UTF8 NAME ${n1}_utf8)

endmacro()

macro(lib name macro)

  add_library(${name} EXCLUDE_FROM_ALL ${ARGN})
  target_compile_definitions(${name} PRIVATE $<$<BOOL:BUILD_SHARED_LIBS>:${macro}=1>)
  target_link_libraries(${name} PRIVATE Boost::system Boost::config)

endmacro()

set(BOOST_TEST_LINK_LIBRARIES Boost::system Boost::core Boost::static_assert)

boost_test(SOURCES quick.cpp)

system_run(error_code_test.cpp)
system_run(error_code_user_test.cpp)
system_run(system_error_test.cpp)

lib(boost_system_throw_test THROW_DYN_LINK throw_test.cpp)
boost_test(SOURCES dynamic_link_test.cpp LINK_LIBRARIES boost_system_throw_test)

system_run(initialization_test.cpp)
system_run(header_only_test.cpp)

boost_test(SOURCES config_test.cpp)

system_run(std_interop_test.cpp)
system_run(std_mismatch_test.cpp)

lib(boost_system_single_instance_lib1 SINGLE_INSTANCE_DYN_LINK single_instance_1.cpp)
lib(boost_system_single_instance_lib2 SINGLE_INSTANCE_DYN_LINK single_instance_2.cpp)

system_run(single_instance_test.cpp single_instance_1.cpp single_instance_2.cpp)
boost_test(SOURCES single_instance_test.cpp NAME single_instance_test_lib LINK_LIBRARIES boost_system_single_instance_lib1 boost_system_single_instance_lib2)

system_run(before_main_test.cpp)
system_run(constexpr_test.cpp)
system_run(win32_hresult_test.cpp)

system_run(error_category_test.cpp)
system_run(generic_category_test.cpp)
system_run(system_category_test.cpp)
system_run(after_main_test.cpp)
system_run(failed_test.cpp)
system_run(failed_constexpr_test.cpp)

boost_test(SOURCES warnings_test.cpp COMPILE_OPTIONS -Wall -Werror)

lib(boost_system_std_single_instance_lib1 STD_SINGLE_INSTANCE_DYN_LINK std_single_instance_1.cpp)
lib(boost_system_std_single_instance_lib2 STD_SINGLE_INSTANCE_DYN_LINK std_single_instance_2.cpp)

system_run(std_single_instance_test.cpp std_single_instance_1.cpp std_single_instance_2.cpp)
boost_test(SOURCES std_single_instance_test.cpp NAME std_single_instance_test_lib LINK_LIBRARIES boost_system_std_single_instance_lib1 boost_system_std_single_instance_lib2)

=== debian/changelog ===
boost1.74 (1.74.0-9) unstable; urgency=medium

  [ Andreas Beckmann ]
  * libboost1.74-dev: Smoothen upgrades from buster by depending on
    libstdc++-${gxx:major}-dev using the build-time version of g++ instead of
    the virtual libstdc++-dev provided by multiple packages.
    (Closes: #984838)

 -- Anton Gladky <gladk@debian.org>  Sat, 13 Mar 2021 09:21:38 +0100

boost1.74 (1.74.0-8) unstable; urgency=medium

  * [85a2610] Fix compilation warnings. (Closes: #980497)
  * [1cd99ad] Set Standards-version to 4.5.1

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Jan 2021 20:00:18 +0100

boost1.74 (1.74.0-7) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * [8b3d244] Fix ptree_serialization failing to build with boost1.74.
    (Closes: #977230)

 -- Anton Gladky <gladk@debian.org>  Mon, 04 Jan 2021 22:17:05 +0100

boost1.74 (1.74.0-6) unstable; urgency=medium

  * [25520d6] Fix detection of ASM-files for mipsel. (Closes: #977921)

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Dec 2020 15:18:55 +0100

boost1.74 (1.74.0-5) unstable; urgency=medium

  [ Pino Toscano ]
  * [6a1ba93] Add a way to identify GNU/Hurd with b2. (Closes: #977414)

  [ Anton Gladky ]
  * [9569ec1] Update watch file format version to 4.

 -- Anton Gladky <gladk@debian.org>  Thu, 17 Dec 2020 21:24:03 +0100

boost1.74 (1.74.0-4) unstable; urgency=medium

  * [283f917] Fix description for nowide-library
  * [fa3c8ab] Add Breaks+Replaces: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
              to libbost1.74-dev. (Closes: #977310)

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Dec 2020 22:55:30 +0100

boost1.74 (1.74.0-3) unstable; urgency=medium

  * [b66a37a] Install b2. (Closes: #975446)
  * [508a668] Bump debhelper from old 10 to 12.
    + debian/rules: Rely on default use of dh_missing rather
      than using dh_install --list-missing.
  * [97c2bd1] Set debhelper-compat version in Build-Depends.
  * [e26eec0] Remove listed license files
  * [51d69a5] Drop transition for old debug package migration.
  * [076941c] Remove Section on some libs  hat duplicate source.

 -- Anton Gladky <gladk@debian.org>  Fri, 27 Nov 2020 20:37:42 +0100

boost1.74 (1.74.0-2) unstable; urgency=medium

  * [a634d58] Add libboost-nowide1.74-dev into libboost1.74-dev.
  * [c60ee8c] Allow graph, log and thread tests to output into stderr.
  * [4b70713] Remove usage of deprecated headers. (Closes: #974577)

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Nov 2020 22:30:42 +0100

boost1.74 (1.74.0-1) unstable; urgency=medium

  * New upstream version.
    + Update Debian patches.
    + Update debian/copyright.
  * Fix little bugs in debian/rules.

 -- Giovanni Mascellani <gio@debian.org>  Sun, 18 Oct 2020 20:13:31 +0200

boost1.71 (1.71.0-7) unstable; urgency=medium

  * Do not install stacktrace_backtrace on m68k, where it is not built
    (closes: #962072). Thanks to Adrian Glaubitz for the patch.
  * Fix broken macOS detection, conflicting with GNU/Hurd
    (closes: #960090). Thanks to Pino Toscano for the patch.
  * Fix some lintian warnings.

 -- Giovanni Mascellani <gio@debian.org>  Mon, 12 Oct 2020 09:50:03 +0200

boost1.71 (1.71.0-6) unstable; urgency=medium

  * [ef8987f] Fix python autopkgtest. (closes: #950688)
  * [aad42c4] Trim trailing whitespace.
  * [5b9edee] Fix failing autopkgtest graph-parallel

 -- Anton Gladky <gladk@debian.org>  Tue, 04 Feb 2020 22:10:35 +0100

boost1.71 (1.71.0-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick further patches to document and optimize context on
    s390x. LP: #1859941
  * Simplify debian/rules slightly, by dropping resetting the default
    values.
  * Skip building numpy on Ubuntu:i386.

  [ Giovanni Mascellani ]
  * Expose Python version information in dependencies to Python packages, so
    that removing a supported Python version does not result in silently
    broken reverse dependencies (closes: #948273). Thanks to Andreas Beckmann
    for the patch.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 30 Jan 2020 15:50:23 +0000

boost1.71 (1.71.0-4) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Transition to the Salsa CI team pipeline.
  * Enable -context on mips64el (closes: #948015).
  * Set graph-parallel test as flaky until
    https://github.com/boostorg/graph_parallel/issues/21 is resolved.
  * Compile test context/demo1.cpp only on amd64, because it uses some
    architecture specific instructions.

  [ Dimitri John Ledkov ]
  * Add chrono to thread autopkgtest until
    https://github.com/boostorg/boost_install/issues/27 is resolved.

 -- Giovanni Mascellani <gio@debian.org>  Fri, 10 Jan 2020 14:26:58 +0100

boost1.71 (1.71.0-3) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Update autopkgtest dependencies to 1.71.
  * Fix some missing dependencies between -dev packages, found thanks to
    autopkgtest.
  * Remove signals from autopkgtest.
  * Cleanup Debian patches.

  [ Dimitri John Ledkov ]
  * Cherrypick upstream patch to enable context on s390x. LP: #1694926

 -- Giovanni Mascellani <gio@debian.org>  Fri, 03 Jan 2020 11:11:45 +0100

boost1.71 (1.71.0-2) unstable; urgency=medium

  * Enable -context on riscv64 (closes: #947651). Thanks to Aurelien Jarno for
    the patch.
  * Install cmake boost_headers files.

 -- Giovanni Mascellani <gio@debian.org>  Tue, 31 Dec 2019 15:25:01 +0100

boost1.71 (1.71.0-1) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Remove myself from uploaders.
  * Provide and Encode icuabi in libboost-regex shlibdeps. This de-couples
    boost & icu transitions.
  * Fix debian/watch to point at dl.bintray.com
  * Drop py2 builds. (Closes: #936227)
  * Drop Debian-only compat py library symlinks. (Closes: #914513)
  * Ship cmake files, hopefully they are right.
  * Enable documentation index.

  [ Giovanni Mascellani ]
  * Add -contract as dependency of -dev-all.
  * Update to new upstream release 1.71.0.
    + Acknowledge removal of signals library.
    + Tweak build script accordingly.


=== debian/control ===
Source: boost1.74
Homepage: https://www.boost.org/
Section: libs
Priority: optional
Maintainer: Debian Boost Team <team+boost@tracker.debian.org>
Uploaders:
 Steve M. Robbins <smr@debian.org>,
 Giovanni Mascellani <gio@debian.org>,
 Anton Gladky <gladk@debian.org>
Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.1~), dctrl-tools, chrpath,
 zlib1g-dev, libbz2-dev, liblzma-dev, libzstd-dev, libicu-dev (>= 63.1), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen,
 docbook-xsl, docbook-xml, texlive-latex-base, ghostscript,
 dh-python,
 g++ (>= 4:5-0),
 python3, python3-all-dev (>= 3.1), python3-numpy
Build-Depends-Indep: graphviz
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: https://salsa.debian.org/debian/boost
Vcs-Git: https://salsa.debian.org/debian/boost.git
Standards-Version: 4.5.1

Package: libboost1.74-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-${gxx:major}-dev
Suggests: libboost1.74-doc,
 libboost-atomic1.74-dev,
 libboost-chrono1.74-dev,
 libboost-container1.74-dev,
 libboost-context1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-contract1.74-dev,
 libboost-coroutine1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.74-dev,
 libboost-exception1.74-dev,
 libboost-fiber1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.74-dev,
 libboost-graph1.74-dev,
 libboost-graph-parallel1.74-dev,
 libboost-iostreams1.74-dev,
 libboost-locale1.74-dev,
 libboost-log1.74-dev,
 libboost-math1.74-dev,
 libboost-mpi1.74-dev,
 libboost-mpi-python1.74-dev,
 libboost-numpy1.74-dev,
 libboost-program-options1.74-dev,
 libboost-python1.74-dev,
 libboost-random1.74-dev,
 libboost-regex1.74-dev,
 libboost-serialization1.74-dev,
 libboost-stacktrace1.74-dev,
 libboost-system1.74-dev,
 libboost-test1.74-dev,
 libboost-thread1.74-dev,
 libboost-timer1.74-dev,
 libboost-type-erasure1.74-dev,
 libboost-wave1.74-dev,
 libboost1.74-tools-dev,
 libmpfrc++-dev, libntl-dev,
 libboost-nowide1.74-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev, libboost1.62-dev, libboost1.63-dev, libboost1.65-dev, libboost1.67-dev, libboost1.70-dev, libboost1.71-dev
Breaks: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Replaces: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.74-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev, libboost1.62-tools-dev, libboost1.63-tools-dev, libboost1.65-tools-dev, libboost1.67-tools-dev, libboost1.70-tools-dev, libboost1.71-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.74-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.74-dev,
 libboost1.74-tools-dev,
 libboost-atomic1.74-dev,
 libboost-chrono1.74-dev,
 libboost-container1.74-dev,
 libboost-context1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-coroutine1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.74-dev,
 libboost-exception1.74-dev,
 libboost-fiber1.74-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.74-dev,
 libboost-graph1.74-dev,
 libboost-graph-parallel1.74-dev,
 libboost-iostreams1.74-dev,
 libboost-locale1.74-dev,
 libboost-log1.74-dev,
 libboost-math1.74-dev,
 libboost-mpi1.74-dev,
 libboost-mpi-python1.74-dev,
 libboost-numpy1.74-dev,
 libboost-program-options1.74-dev,
 libboost-python1.74-dev,
 libboost-random1.74-dev,
 libboost-regex1.74-dev,
 libboost-serialization1.74-dev,
 libboost-stacktrace1.74-dev,
 libboost-system1.74-dev,
 libboost-test1.74-dev,
 libboost-thread1.74-dev,
 libboost-timer1.74-dev,
 libboost-type-erasure1.74-dev,
 libboost-wave1.74-dev,
 libboost-nowide1.74-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.74-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-mathjax
Suggests: libboost1.74-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc, libboost1.62-doc, libboost1.63-doc, libboost1.65-doc, libboost1.67-doc, libboost1.70-doc, libboost1.71-doc
Description: Boost.org libraries documentation placeholder
 This package originally provided documentation, but has since fallen
 into disrepair and presently provides no documentation.  Please
 use documentation at www.boost.org.

Package: libboost-atomic1.74.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.74-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.74-dev (= ${binary:Version}),
 libboost-atomic1.74.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev, libboost-atomic1.62-dev, libboost-atomic1.63-dev, libboost-atomic1.65-dev, libboost-atomic1.67-dev, libboost-atomic1.70-dev, libboost-atomic1.71-dev

Package: libboost-chrono1.74.0
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono
 provides a number of clocks that are thin wrappers around the
 operating system's time APIs, thereby allowing the extraction of wall
 clock time, user CPU time, system CPU time spent by the process:
 .
  * process_real_cpu_clock, captures wall clock CPU time spent by the
    current process.
  * process_user_cpu_clock, captures user-CPU time spent by the current
    process.
  * process_system_cpu_clock, captures system-CPU time spent by the
    current process.
  * a tuple-like class process_cpu_clock, that captures real, user-CPU,
    and system-CPU process times together.
  * a thread_clock thread steady clock giving the time spent by the

=== debian/rules ===
#! /usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono container contract date-time exception filesystem	\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python nowide program-options python random regex	\
              serialization stacktrace system test thread timer \
              type-erasure wave

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
ifeq ($(DEB_BUILD_ARCH), m68k)
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=962072
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_basic
else
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_backtrace stacktrace_basic
endif
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

pyversions = $(shell py3versions -rv)
pyverids = $(subst .,,$(pyversions))

# These are special cases for suffixes.
boost_suffixes_python := $(pyverids)
boost_suffixes_numpy := $(pyverids)
boost_suffixes_mpi-python := $(pyverids)

# Files that are generated by filtering a template
filtered_files =

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

version_full := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
version_upstream := $(shell echo $(version_full) | cut -d'-' -f1)
version_major := $(shell echo $(version_upstream) | cut -d'.' -f1,2)

PKGVERSION = $(version_major)
SOVERSION = $(version_upstream)

icuabi = $(shell apt show libicu-dev 2>/dev/null | sed -n 's/Depends: .*libicu\([0-9]*\) .*/\1/p')
regexicuabi = libboost-regex$(SOVERSION)-icu$(icuabi)

# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component
boost_suffixes = $(if $(boost_suffixes_$(1)), $(boost_suffixes_$(1)),"")

# Helpers to make basic and decorated library names
# Input: library, suffix
# Return: base library filename for short or full name
mk_base_name = usr/lib/$(DEB_HOST_MULTIARCH)/libboost_$(subst -,_,$(1))$(2)
mk_cmake_name = usr/lib/$(DEB_HOST_MULTIARCH)/cmake/boost_$(subst -,_,$(1))-$(SOVERSION)/

# Input: component
# Return: package name for shared library or development
mk_pkg_lib = libboost-$(1)$(SOVERSION)
mk_pkg_dev = libboost-$(1)$(PKGVERSION)-dev

# Helpers to generate debhelper input filenames.
# Input: component
# Return: prefix to debhelper filenames
mk_deb_lib = debian/$(call mk_pkg_lib,$(1))
mk_deb_dev = debian/$(call mk_pkg_dev,$(1))

# Helpers that update debhelper .install or .links files
# Input: component, library, suffix
# Output: none
mk_so_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).so.$(SOVERSION) >> $(call mk_deb_lib,$(1)).install)
mk_a_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).a >> $(call mk_deb_dev,$(1)).install)
mk_ln_files = $(shell echo $(call mk_base_name,$(2),$(3)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3)).so >> $(call mk_deb_dev,$(1)).links)
mk_cmake_files = $(shell echo debian/tmp/$(call mk_cmake_name,$(2),$(3)) >> $(call mk_deb_dev,$(1)).install)

# Specify the type of files/links to install.
# Special cases first, then general rule
boost_filetypes_exception = a cmake
boost_filetypes_test_exec_monitor = a cmake
boost_filetypes = $(if $(boost_filetypes_$(1)), $(boost_filetypes_$(1)),a so ln cmake)

# Function that updates debhelper files for a given library
# Input: component, library, suffix
# Output: none
mk_files = $(foreach fn,$(call boost_filetypes,$(2)),$(call mk_$(fn)_files,$(1),$(2),$(3)))

# helpers to make and install lintian override files

# Input: package, override
add_override = echo $(1): $(2) >> debian/$(1).lintian-overrides;

# Input: override
add_dev_override = $(call add_override,libboost$(PKGVERSION)-dev,$(1))
add_doc_override = $(call add_override,libboost$(PKGVERSION)-doc,$(1))

# Input: component, lintian-warning
add_lib_override = $(call add_override,$(call mk_pkg_lib,$(1)),$(2))
add_libdev_override = $(call add_override,$(call mk_pkg_dev,$(1)),$(2))

# Input: package-name-base, versioned-package-name
cp_debhelper = set -e ; for s in doc-base examples postinst prerm README.Debian; do \
	if test -f debian/$(1).$$s; then cp -f debian/$(1).$$s debian/$(2).$$s; fi; done

# Function that updates debhelper files for all libraries shipped.
mk_debhelper_files = \
	$(call add_dev_override,extra-license-file) \
	$(call add_doc_override,extra-license-file) \
	$(foreach l, $(boost_libs), \
		echo "making debhelper files for $(l)..."; \
		$(call add_lib_override,$(l),package-name-doesnt-match-sonames) \
		$(foreach ll, $(call boost_lib,$(l)), \
			$(foreach suf, $(call boost_suffixes,$(l)), \
				$(call mk_files,$(l),$(ll),$(suf)) \
			) \
		) \
	)

TOOLSET_CONFIG = 'using gcc : : : <compileflags>"$(CPPFLAGS)" <cflags>"$(CFLAGS)" <cxxflags>"$(CXXFLAGS) -Wno-unused-local-typedefs" <linkflags>"$(LDFLAGS)" ;'
BUILD_CONTEXT = yes
BUILD_LONG_DOUBLE = yes
BUILD_NUMPY = yes

ifeq ($(DEB_BUILD_ARCH), alpha)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), arm)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), armel)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), armhf)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), arm64)
BUILD_LONG_DOUBLE = no
JAM_OPT += pch=off
else ifeq ($(DEB_BUILD_ARCH), hppa)
BUILD_LONG_DOUBLE = no
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), i386)
ifeq ($(DEB_VENDOR), Ubuntu)
BUILD_NUMPY = no
endif
else ifeq ($(DEB_BUILD_ARCH), ia64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), m68k)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), mips)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mipsel)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mips64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), powerpcspe)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), s390)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sh4)
BUILD_LONG_DOUBLE = no
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sparc)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sparc64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), x32)
BUILD_CONTEXT = no
endif

ifeq ($(BUILD_CONTEXT), yes)
boost_libs += context coroutine fiber
else
JAM_WITHOUT += --without-context --without-coroutine --without-fiber
endif

ifeq ($(BUILD_LONG_DOUBLE), yes)
boost_lib_math += $(boost_lib_math_long_double)
else
JAM_OPT += --disable-long-double
endif

ifeq ($(BUILD_NUMPY), yes)
boost_libs += numpy
endif

exampledir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/examples
b2 = $(CURDIR)/b2
bbv2dir = $(CURDIR)/tools/build

# With --ignore-site-config, can probably drop Build-Conflicts on boost-build.
JAM = $(b2) $(JOBS) -q -d2 $(JAM_OPT) --layout=system --ignore-site-config --user-config=$(CURDIR)/user-config.jam debug-symbols=on
JAM_DOC = $(b2) $(JOBS) -q -d2 --ignore-site-config --user-config=$(CURDIR)/user-config-doc.jam --enable-index

%:
	dh $@ --with python3

override_dh_auto_configure: user-config.jam make-debhelper
ifeq ($(DEB_BUILD_ARCH), x32)
	cp tools/build/src/tools/gcc.jam tools/build/src/tools/gcc.jam.bak
	sed -i -e 's|^.*compile-link-flags.*-m32.*|#\0|g' tools/build/src/tools/gcc.jam
endif

override_dh_auto_build-common: $(b2) b2.1 bjam.1

=== debian/tests/control ===
Tests: atomic
Depends: libboost-atomic1.71-dev, build-essential, cmake

Tests: chrono
Depends: libboost-chrono1.71-dev, libboost-system1.71-dev, build-essential, cmake

Tests: context
Depends: libboost-context1.71-dev, build-essential, cmake

Tests: container
Depends: libboost-container1.71-dev, libboost-system1.71-dev, build-essential, cmake

Tests: coroutine
Depends: libboost-coroutine1.71-dev, libboost-system1.71-dev, build-essential, cmake

Tests: datetime
Depends: libboost-date-time1.71-dev, build-essential, cmake

Tests: exception
Depends: libboost-exception1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: fiber
Depends: libboost-fiber1.71-dev, build-essential, cmake

Tests: filesystem
Depends: libboost-filesystem1.71-dev, build-essential, cmake

Tests: graph
Depends: libboost-graph1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: graph-parallel
Depends: libboost-graph-parallel1.71-dev, libboost-mpi1.71-dev, libboost-system1.71-dev, mpi-default-dev, build-essential, libgraph-easy-perl, cmake
Restrictions: allow-stderr

Tests: iostreams
Depends: libboost-iostreams1.71-dev, build-essential, cmake

Tests: locale
Depends: libboost-locale1.71-dev, build-essential, cmake

Tests: log
Depends: libboost-log1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: math
Depends: libboost-math1.71-dev, build-essential, cmake

Tests: mpi
Depends: libboost-mpi1.71-dev, mpi-default-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: mpi-python
Depends: libboost-mpi-python1.71-dev, mpi-default-dev, python3-minimal
Restrictions: allow-stderr

Tests: program-options
Depends: libboost-program-options1.71-dev, build-essential, cmake

Tests: python
Depends: libboost-python1.71-dev, python3-minimal, cmake, build-essential, clang

Tests: random
Depends: libboost-random1.71-dev, build-essential, cmake

Tests: regex
Depends: libboost-regex1.71-dev, build-essential, cmake, html2text

Tests: serialization
Depends: libboost-serialization1.71-dev, libboost-random1.71-dev, build-essential, cmake

Tests: stacktrace
Depends: libboost-stacktrace1.71-dev, libboost-system1.71-dev, build-essential, cmake

Tests: system
Depends: libboost-system1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: test
Depends: libboost-test1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: thread
Depends: libboost-thread1.71-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: timer
Depends: libboost-timer1.71-dev, build-essential, cmake

Tests: type-erasure
Depends: libboost-type-erasure1.71-dev, build-essential, cmake

Tests: wave
Depends: libboost-wave1.71-dev, libboost-thread1.71-dev, build-essential, cmake
